-- local dragData = {};
-- dragData.datas = Array();
-- dragData.datas:add(LanUtil.getValue(110809));
-- dragData.datas:add(LanUtil.getValue(110810));
-- dragData.datas:add(LanUtil.getValue(110811));
-- dragData.datas:add(LanUtil.getValue(20));
-- dragData.offsetX = -434;
-- dragData.offsetY = -44;
-- dragData.callBackOwner = self;
-- dragData.callBack = self.onDragDownCallBack;
-- dragData.selected = 4;
-- Lua_WindowUtil.openWin("Lua_DragDownWindow", nil, dragData);

checkRequire("Lua_DragDownItem");
Lua_DragDownWindow = class("Lua_DragDownWindow", Lua_Window);
function Lua_DragDownWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_DragDownWindow";
	self.layer = 3500;
	if getCVersion() >= 1240 then
		self.isClickClose = false;
		self.isModel = false;
	else
		self.isClickClose = true;
		self.isModel = true;
	end
	self.showClose = false;
	self.showBg = false;
	self.blackAlpha = 0.02;
	self.setHasBlackMask = false;
end

function Lua_DragDownWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.showTime = getTime();

	self:addLuaEvent("DRAGDOWN_CLICK", self, self.onDragDownClick);
	self:addCSharpEvent("UICAMERA_CLICK", self, self.onCameraClick);
end

function Lua_DragDownWindow:showWin(param)
	local len = param.datas:getSize();
	local heights = {88, 131, 174, 217};
	local h = len > 4 and 4 or len;
	local width = param.width == nil and 196 or param.width;
	local height = param.height == nil and heights[h] or param.height;
	if self.dragList ~= nil then
		self.dragList:dispose();
		self.dragList = nil;
	end
	if self.bg ~= nil then
		self.bg:dispose();
		self.bg = nil;
	end
	self.dragList = Lua_DragList.new(self.content,1, Vector4(0, 0, width, height - 15));

	local itemWidth = param.itemWidth == nil and 178 or param.itemWidth;
	local arr = Array();
	local fontSize = param.fontSize == nil and 20 or param.fontSize;
	for i = 1, len do
		local a = {};
		a.index = i;
		a.selected = param.selected == i;
		a.text = param.datas[i];
		a.width = itemWidth;
		a.height = param.rowSpacing == nil and 43 or param.rowSpacing;
		a.flowerWin = param.flowerWin;
		a.itemBgAltas = param.itemBgAltas;
		a.itemNotSelectSprite = param.itemNotSelectSprite;
		a.itemSelectSprite = param.itemSelectSprite;
		a.fontSize = fontSize;
		arr:add(a);
	end
	self.dragList:setLocation(param.offsetX, param.offsetY, 0);

	if param.bgAltas == nil and param.bgSprite == nil then
		self.bg = UICreate.createUIAtlasImage(self.content, "common_atlas_1", "ui_common_widget_01", 0, 0, width, height);
		self.dragList:setListCell(Lua_DragDownItem, 51, width, 1);
	else
		self.bg = UICreate.createUIAtlasImage(self.content, param.bgAltas, param.bgSprite, 0, 0, width, height);
		self.dragList:setListCell(Lua_DragDownItem, param.rowSpacing + 8, width, 1);
	end
	self.dragList:setLuaArrayData(arr);
	if len > 4 then
		self.dragList:moveToIndex(param.selected,true);
	end

	local bgOffsetX = param.bgOffsetX == nil and 0 or param.bgOffsetX;
	self.bg:setLocation(param.offsetX + bgOffsetX, param.offsetY, 0);
	self.owner = param.callBackOwner;
	self.callBack = param.callBack;
	self:updateWindowDepth();
end

function Lua_DragDownWindow:onDragDownClick(val)
	if self.callBack ~= nil and self.owner ~= nil then
		local w = self.owner;
		local f = self.callBack;
		self.owner = nil;
		self.callBack = nil;
		f(w, val);
	end
	self:hide();
end

function Lua_DragDownWindow:onCameraClick(val)
	if getTime() - self.showTime < 0.5 then
		return;
	end
	
	local v = Vector3(UnityEngine.Input.mousePosition.x,UnityEngine.Input.mousePosition.y,0);
	local screenpos = UICamera.mainCamera:ScreenToWorldPoint(v);
	local mousePosition = self.bg.mainContent.transform:InverseTransformPoint(screenpos);
	local hw = self.bg.width / 2;
	local hh = self.bg.height / 2;
	if mousePosition.x > hw or mousePosition.x < -hw or mousePosition.y < -hh or mousePosition.y > hh then
		self:hide();
	end
end

function Lua_DragDownWindow:dispose()
	self.owner = nil;
	self.callBack = nil;
	self:superCall("dispose");
end